/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2008 The LS-Universe Team

    Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_)
#define AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../xPaintClass/xExports.h"

#include <shlobj.h>

#define StringCchCopy(a, b, c) strncpy((a), (c), (b))
#define StringCchLength(a, b, c) *(c) = strlen((a)), S_OK
#define StringCchPrintf _snprintf

class CompletePaintClasses 
{
public:
	CompletePaintClasses() :
	  	pPopupTexture(NULL),
		
		pEntryTexture(NULL),
		pActiveEntryTexture(NULL),
		pFolderTexture(NULL),
		pActiveFolderTexture(NULL),
		pInfoTexture(NULL),
		pActiveInfoTexture(NULL),
		pTitleTexture(NULL),
		pBottomTexture(NULL),
		pSeparatorTexture(NULL),
		pArrowTexture(NULL),
		pActiveArrowTexture(NULL),

		pEntryIcon(NULL),
		pActiveEntryIcon(NULL),
		pFolderIcon(NULL),
		pActiveFolderIcon(NULL),
		pInfoIcon(NULL),
		pActiveInfoIcon(NULL),

		pTitleIcon(NULL),
		pPinnedIcon(NULL),

		pEntryText(NULL),
		pActiveEntryText(NULL),
		pFolderText(NULL),
		pActiveFolderText(NULL),
		pInfoText(NULL),
		pActiveInfoText(NULL),
		pTitleText(NULL),

		pArrowText(NULL),
		pActiveArrowText(NULL)
	{	
		pPopupTexture = Create_xTextureClass();
		
		pEntryTexture = Create_xTextureClass();
		pActiveEntryTexture = Create_xTextureClass();
		pFolderTexture = Create_xTextureClass();
		pActiveFolderTexture = Create_xTextureClass();
		pInfoTexture = Create_xTextureClass();
		pActiveInfoTexture = Create_xTextureClass();
		pTitleTexture = Create_xTextureClass();
		pBottomTexture = Create_xTextureClass();
		pSeparatorTexture = Create_xTextureClass();
		pArrowTexture = Create_xTextureClass();
		pActiveArrowTexture = Create_xTextureClass();

		pEntryIcon = Create_xIconClass();
		pActiveEntryIcon = Create_xIconClass();
		pFolderIcon = Create_xIconClass();
		pActiveFolderIcon = Create_xIconClass();
		pInfoIcon = Create_xIconClass();
		pActiveInfoIcon = Create_xIconClass();

		pTitleIcon = Create_xIconClass();
		pPinnedIcon = Create_xIconClass();

		pEntryText = Create_xTextClass();
		pActiveEntryText = Create_xTextClass();
		pFolderText = Create_xTextClass();
		pActiveFolderText = Create_xTextClass();
		pInfoText = Create_xTextClass();
		pActiveInfoText = Create_xTextClass();
		pTitleText = Create_xTextClass();

		pArrowText = Create_xTextClass();
		pActiveArrowText = Create_xTextClass();
	};

	virtual ~CompletePaintClasses()
	{
		if (pPopupTexture)
			Destroy_xTextureClass(pPopupTexture);
		
		if (pEntryTexture)
			Destroy_xTextureClass(pEntryTexture);
		if (pActiveEntryTexture)
			Destroy_xTextureClass(pActiveEntryTexture);
		if (pFolderTexture)
			Destroy_xTextureClass(pFolderTexture);
		if (pActiveFolderTexture)
			Destroy_xTextureClass(pActiveFolderTexture);
		if (pInfoTexture)
			Destroy_xTextureClass(pInfoTexture);
		if (pActiveInfoTexture)
			Destroy_xTextureClass(pActiveInfoTexture);
		if (pTitleTexture)
			Destroy_xTextureClass(pTitleTexture);
		if (pBottomTexture)
			Destroy_xTextureClass(pBottomTexture);
		if (pSeparatorTexture)
			Destroy_xTextureClass(pSeparatorTexture);
		if (pArrowTexture)
			Destroy_xTextureClass(pArrowTexture);
		if (pActiveArrowTexture)
			Destroy_xTextureClass(pActiveArrowTexture);

		if (pEntryIcon)
			Destroy_xIconClass(pEntryIcon);
		if (pActiveEntryIcon)
			Destroy_xIconClass(pActiveEntryIcon);
		if (pFolderIcon)
			Destroy_xIconClass(pFolderIcon);
		if (pActiveFolderIcon)
			Destroy_xIconClass(pActiveFolderIcon);
		if (pInfoIcon)
			Destroy_xIconClass(pInfoIcon);
		if (pActiveInfoIcon)
			Destroy_xIconClass(pActiveInfoIcon);

		if (pTitleIcon)
			Destroy_xIconClass(pTitleIcon);
		if (pPinnedIcon)
			Destroy_xIconClass(pPinnedIcon);

		if (pEntryText)
			Destroy_xTextClass(pEntryText);
		if (pActiveEntryText)
			Destroy_xTextClass(pActiveEntryText);
		if (pFolderText)
			Destroy_xTextClass(pFolderText);
		if (pActiveFolderText)
			Destroy_xTextClass(pActiveFolderText);
		if (pInfoText)
			Destroy_xTextClass(pInfoText);
		if (pActiveInfoText)
			Destroy_xTextClass(pActiveInfoText);
		if (pTitleText)
			Destroy_xTextClass(pTitleText);

		if (pArrowText)
			Destroy_xTextClass(pArrowText);
		if (pActiveArrowText)
			Destroy_xTextClass(pActiveArrowText);

		pPopupTexture = NULL;
		
		pEntryTexture = NULL;
		pActiveEntryTexture = NULL;
		pFolderTexture = NULL;
		pActiveFolderTexture = NULL;
		pInfoTexture = NULL;
		pActiveInfoTexture = NULL;
		pTitleTexture = NULL;
		pBottomTexture = NULL;
		pSeparatorTexture = NULL;
		pArrowTexture = NULL;
		pActiveArrowTexture = NULL;

		pEntryIcon = NULL;
		pActiveEntryIcon = NULL;
		pFolderIcon = NULL;
		pActiveFolderIcon = NULL;
		pInfoIcon = NULL;
		pActiveInfoIcon = NULL;

		pTitleIcon = NULL;
		pPinnedIcon = NULL;

		pEntryText = NULL;
		pActiveEntryText = NULL;
		pFolderText = NULL;
		pActiveFolderText = NULL;
		pInfoText = NULL;
		pActiveInfoText = NULL;
		pTitleText = NULL;

		pArrowText = NULL;
		pActiveArrowText = NULL;
	};

	PaintTexture *pPopupTexture;

	PaintTexture *pEntryTexture;
	PaintTexture *pActiveEntryTexture;
	PaintTexture *pFolderTexture;
	PaintTexture *pActiveFolderTexture;
	PaintTexture *pInfoTexture;
	PaintTexture *pActiveInfoTexture;
	PaintTexture *pTitleTexture;
	PaintTexture *pBottomTexture;
	PaintTexture *pSeparatorTexture;
	PaintTexture *pArrowTexture;
	PaintTexture *pActiveArrowTexture;

	PaintIcon *pEntryIcon;
	PaintIcon *pActiveEntryIcon;
	PaintIcon *pFolderIcon;
	PaintIcon *pActiveFolderIcon;
	PaintIcon *pInfoIcon;
	PaintIcon *pActiveInfoIcon;

	PaintIcon *pTitleIcon;
	PaintIcon *pPinnedIcon;

	PaintText *pEntryText;
	PaintText *pActiveEntryText;
	PaintText *pFolderText;
	PaintText *pActiveFolderText;
	PaintText *pInfoText;
	PaintText *pActiveInfoText;

	PaintText *pTitleText;
	PaintText *pArrowText;
	PaintText *pActiveArrowText;
};

string trim(const string &toTrim);
string IntToString(int input);

int SplitString(const string &process, string &one, string &two, string &three, string &four, string &five, string &six, string &seven);

string iGetxRCString(const string &uniqueKey, const string &baseName, const string &defaultVal);
string iGetx2RCString(const string &uniqueKey, const string &baseName, const string &defaultVal);

string iGetxRCLine(const string &uniqueKey, const string &baseName, const string &defaultVal);
string iGetx2RCLine(const string &uniqueKey, const string &baseName, const string &defaultVal);

void PrefixedLSSetVariable(string prefix, string var, string value);

vector<string> split(string str, string sep);

string TrimAndStripQuote(string input, bool removeslash = false);

HICON RetrieveIcon(const string &iconPath, const HWND iconhWnd, const LPITEMIDLIST iconpidl, const string &DefaultIcon, bool bBigIcon);

HICON GetIconFromPathEx(LPCSTR pszPath, bool bBigIcon);

HICON GetTaskIcon(HWND hTask, bool bBigIcon);

StringList GetxRCLineList(const string &uniqueKey);

void GetxRCList(char *text, StringList &theList, string cfgpath = "");

#endif // !defined(AFX_UTILITIES_H__54F0E0FB_ABA1_4BDC_9F6B_8DF661DA0BD2__INCLUDED_)
